"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _enjoyWebSupport = require("enjoy-web-support");

var _index = require("./index-css");

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ScrollView = function (_WebScrollView) {
	_inherits(ScrollView, _WebScrollView);

	function ScrollView() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, ScrollView);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ScrollView.__proto__ || Object.getPrototypeOf(ScrollView)).call.apply(_ref, [this].concat(args))), _this), _this.isReflow = false, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(ScrollView, [{
		key: "calc",
		value: function calc() {
			if (this.props.horizontal) {
				if (this.isReflow) {
					this.isReflow = false;
				} else {
					this.isReflow = true;
					this.setState({
						contentWidth: this.refs.content.offsetWidth
					});
				}
			}
		}
	}, {
		key: "componentDidMount",
		value: function componentDidMount() {
			_get(ScrollView.prototype.__proto__ || Object.getPrototypeOf(ScrollView.prototype), "componentDidMount", this).call(this);

			this.calc();
		}
	}, {
		key: "componentDidUpdate",
		value: function componentDidUpdate() {
			_get(ScrollView.prototype.__proto__ || Object.getPrototypeOf(ScrollView.prototype), "componentDidUpdate", this).call(this);

			this.calc();
		}
	}, {
		key: "render",
		value: function render() {
			var _props = this.props,
			    children = _props.children,
			    className = _props.className,
			    style = _props.style,
			    contentContainerStyle = _props.contentContainerStyle,
			    horizontal = _props.horizontal,
			    onEndPoint = _props.onEndPoint,
			    onScroll = _props.onScroll,
			    endPointThreshold = _props.endPointThreshold,
			    props = _objectWithoutProperties(_props, ["children", "className", "style", "contentContainerStyle", "horizontal", "onEndPoint", "onScroll", "endPointThreshold"]);

			className = className ? [className] : [];
			className.push("ej-scroll-view");

			var containerStyle = {};
			var contentStyle = {};

			if (horizontal) {
				className.push("ej-scroll-view-h");

				if (this.isReflow) {
					contentStyle.width = this.state.contentWidth;
				} else {
					containerStyle.position = "relative";
					contentStyle.position = "absolute";
				}
			}

			return _enjoyWebSupport.React.createElement(
				"div",
				_extends({
					ref: "container",
					className: className.join(" "),
					style: Object.assign(containerStyle, style)
				}, props, this.events),
				_enjoyWebSupport.React.createElement(
					"div",
					{
						ref: "content",
						className: horizontal ? "ej-scroll-view-content ej-scroll-view-h-content" : "ej-scroll-view-content",
						style: Object.assign(contentStyle, contentContainerStyle) },
					children
				)
			);
		}
	}]);

	return ScrollView;
}(_enjoyWebSupport.ScrollView);

exports.default = ScrollView;