"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Head = function (_React$Component) {
	_inherits(Head, _React$Component);

	function Head() {
		_classCallCheck(this, Head);

		return _possibleConstructorReturn(this, (Head.__proto__ || Object.getPrototypeOf(Head)).apply(this, arguments));
	}

	_createClass(Head, [{
		key: "render",
		value: function render() {
			var _props = this.props,
			    style = _props.style,
			    children = _props.children,
			    props = _objectWithoutProperties(_props, ["style", "children"]);

			style = style || {};

			var isEmpty = true;
			_react2.default.Children.forEach(children, function (item) {
				if (typeof item === "string") {
					isEmpty = false;
				}

				var classNames = item.props.className.trim().split(/\s+/);
				var childrenCount = _react2.default.Children.count(item.props.children);
				if (classNames.indexOf("ej-tag-title") !== -1) {
					if (childrenCount !== 0 && typeof item.props.children !== "string") {
						isEmpty = false;
					}
				} else if (classNames.indexOf("ej-tag-left") !== -1) {
					var child = void 0;
					if (childrenCount !== 0 && (childrenCount !== 1 || (child = _react2.default.Children.only(item.props.children)) && (typeof child === "string" || child.props.className.trim().split(/\s+/).indexOf("ej-tag-back") === -1))) {
						isEmpty = false;
					}
				} else if (classNames.indexOf("ej-tag-right") !== -1) {
					if (childrenCount !== 0) {
						isEmpty = false;
					}
				} else {
					isEmpty = false;
				}
			});
			if (isEmpty) {
				style.visibility = "hidden";
			}

			return _react2.default.createElement(
				"div",
				_extends({}, props, { style: style }),
				children
			);
		}
	}]);

	return Head;
}(_react2.default.Component);

exports.default = Head;