"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _enjoyWebSupport = require("enjoy-web-support");

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

//距离失效3s 前重新请求签名
var JSSDKCONFIGTIME = 7197000;
//获取微信签名的跨域接口
var GETWXSIGN = "//mp.elong.com/mobilepromotion/getwxconfig";
//获取微信jssdk连接
var WXJSSDKURL = "//res.wx.qq.com/open/js/jweixin-1.0.0.js ";

exports.default = {
	callback: function callback() {},

	ready: function ready(callback) {
		var _this = this;

		return _asyncToGenerator(regeneratorRuntime.mark(function _callee() {
			var oScript;
			return regeneratorRuntime.wrap(function _callee$(_context) {
				while (1) {
					switch (_context.prev = _context.next) {
						case 0:
							if (!window["wx"]) {
								console.log("请正确引用jssdk");
								oScript = document.createElement("script");

								oScript.type = "text/javascript";
								oScript.src = location.protocol + WXJSSDKURL;
								document.body.appendChild(oScript);
							}

							_this.callback = callback;

							_context.next = 4;
							return _this.updateSign();

						case 4:
						case "end":
							return _context.stop();
					}
				}
			}, _callee, _this);
		}))();
	},
	updateSign: function updateSign() {
		var now = new Date().getTime();
		window.configCallback = this.configCallback;
		window.__WEIXINCALLBACK__ = this.callback;
		//判断签名是否失效
		if ("weixinSign" in window && Number(window.weixinSign.timestamp) + JSSDKCONFIGTIME <= now) {
			return this.getSign();
		} else if (!window["weixinSign"]) {
			return this.getSign();
		} else {
			wx.ready(this.callback);
			return;
		}
	},
	getSign: function getSign() {
		var _this2 = this;

		return _asyncToGenerator(regeneratorRuntime.mark(function _callee2() {
			var nowTime, result;
			return regeneratorRuntime.wrap(function _callee2$(_context2) {
				while (1) {
					switch (_context2.prev = _context2.next) {
						case 0:
							_context2.prev = 0;
							nowTime = new Date().getTime();
							_context2.next = 4;
							return (0, _enjoyWebSupport.Fetch)(location.protocol + GETWXSIGN + '?v=' + nowTime, {
								method: 'Get'
							});

						case 4:
							result = _context2.sent;

							_this2.configCallback(result);
							_context2.next = 11;
							break;

						case 8:
							_context2.prev = 8;
							_context2.t0 = _context2["catch"](0);

							console.log(JSON.stringify(_context2.t0));

						case 11:
						case "end":
							return _context2.stop();
					}
				}
			}, _callee2, _this2, [[0, 8]]);
		}))();
	},
	configCallback: function configCallback(resp) {
		console.log('in');
		if (resp.error == false && "wx" in window) {
			var data = resp.data;
			window.weixinSign = {
				debug: false,
				appId: data.appId,
				timestamp: data.timestamp,
				nonceStr: data.nonceStr,
				signature: data.signature,
				jsApiList: []
			};
			wx.config(Object.assign({}, window.weixinSign, {
				debug: false,
				jsApiList: ['getLocation', 'hideMenuItems', 'showMenuItems', 'hideAllNonBaseMenuItem', 'onMenuShareTimeline', 'onMenuShareAppMessage', 'onMenuShareQQ', 'onMenuShareQZone']
			}));
			wx.ready(__WEIXINCALLBACK__);
		}
	}
};